//#extension GL_OES_standard_derivatives : enable

uniform vec2 TextureSize0;
uniform sampler2D Texture1;
varying mediump vec2	myTexCoord;
varying mediump vec4	myTexColor;

//vec2 saturate(vec2 x)
//{
//	return clamp(x, 0.0, 1.0);   
//}
//vec2 magnify(vec2 uv)
//{
//    uv *= TextureSize0.xy; 
//    return (saturate(fract(uv) / saturate(fwidth(uv))) + floor(uv) - 0.5) / TextureSize0.xy;
//}

void main (void)
{
	vec2 uv = myTexCoord;

	vec2 uv_final = uv;//magnify(uv);

	vec4 color = texture2D(Texture1, uv_final);
	color.rgb *= color.a;
	color.rgb *= 1.5;
	  
	float _dx = 2.0 * 1.0 / TextureSize0.x;
	float _dy = 2.0 * 1.0 / TextureSize0.y;
	// Move sprite in 4 directions according to width, we only care about the alpha
	float spriteLeft	= texture2D(Texture1, uv_final + vec2(_dx,  0)).a;
	float spriteRight	= texture2D(Texture1, uv_final - vec2(_dx,  0)).a;
	float spriteBottom	= texture2D(Texture1, uv_final + vec2( 0 ,_dy)).a;
	float spriteTop		= texture2D(Texture1, uv_final - vec2( 0 ,_dy)).a;	
	
    // then combine
	float result = (spriteRight + spriteLeft + spriteTop+ spriteBottom);
	// delete original alpha to only leave outline
	result *= (1.0 - color.a);	
	
	vec4 outline = vec4(0.1,0.1,0.1,	1);
	outline = outline * result * 1.0;
	color = color + outline;
	
	gl_FragColor = color;
}
